//----------------------------------------------------------------------------
// ObjectWindows - (C) Copyright 1991, 1993 by Borland International
//----------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\dialog.h>
#include <owl\dc.h>
#include <stdio.h>
#include "arty.h"
#include "owlscrn.h"

const char OwlScrnSectionStr[] = "OWLScrSaveDance";
const char SpeedStr[] = "Speed";
char  AppName[]  = "OWLDancingLines";

//----------------------------------------------------------------------------

class TScrnSavDlg : public TDialog {
  public:
	 TScrnSavDlg(TWindow* parent, const char far* name, TModule* module)
		: TDialog(parent, name, module) {}

	 void SetupWindow();
	 void CloseWindow(int retValue);

  DECLARE_RESPONSE_TABLE(TScrnSavDlg);
};

DEFINE_RESPONSE_TABLE1(TScrnSavDlg, TDialog)
  EV_COMMAND(IDCANCEL, CmCancel),
END_RESPONSE_TABLE;

void
TScrnSavDlg::SetupWindow()
{
  char settings[32];

  int speed;
  ::GetProfileString(OwlScrnSectionStr, SpeedStr, "2",
							settings, sizeof(settings));
  sscanf(settings, "%d", &speed);
  CheckRadioButton(ID_SLOW, ID_FAST, ID_SLOW+speed);
}

void
TScrnSavDlg::CloseWindow(int retValue)
{
  char settings[32];

  wsprintf(settings, "%d", IsDlgButtonChecked(ID_SLOW) ? 0 :
									(IsDlgButtonChecked(ID_MED) ? 1 : 2));
  WriteProfileString(OwlScrnSectionStr, SpeedStr, settings);

  TDialog::CloseWindow(retValue);
}

//----------------------------------------------------------------------------

class TMyScrnSavApp : public TScrnSavApp {
  public:
	 TMyScrnSavApp(char far* name) : TScrnSavApp(name) { }

	 // Override TScrnSavApp's virtual functions
	 //
	 void  InitScrnSavWindow();
	 void  InitConfigDialog();
};

void
TMyScrnSavApp::InitScrnSavWindow()
{
  ScrnSavWnd = new TArtyWindow(0, AppName);
}

void
TMyScrnSavApp::InitConfigDialog()
{
  ConfigureDialog = new TScrnSavDlg((TWindow *) 0, MAKEINTRESOURCE(IDD_CONFIGURE),(TModule *) this);
}

int
OwlMain(int /*argc*/, char* /*argv*/ [])
{
  return TMyScrnSavApp(AppName).Run();
}

